Index: libraries/javalib/java/awt/AWTEvent.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/AWTEvent.java,v
retrieving revision 1.20
diff -u -r1.20 AWTEvent.java
--- libraries/javalib/java/awt/AWTEvent.java	25 May 2004 10:17:08 -0000	1.20
+++ libraries/javalib/java/awt/AWTEvent.java	8 Jul 2004 12:08:58 -0000
@@ -1,23 +1,25 @@
+/*
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ *
+ * @author P.C.Mehlitz
+ */
+
 package java.awt;
 
 import java.awt.event.MouseEvent;
 import java.util.EventObject;
 
+import kaffe.awt.Defaults;
 import kaffe.awt.FocusHook;
 import kaffe.awt.KeyHook;
 import kaffe.awt.MouseHook;
 import kaffe.util.Ptr;
 
-/**
- *
- * Copyright (c) 1998
- *   Transvirtual Technologies Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * @author P.C.Mehlitz
- */
 public class AWTEvent
   extends EventObject
 {
Index: libraries/javalib/java/awt/ActionEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/ActionEvt.java,v
retrieving revision 1.6
diff -u -r1.6 ActionEvt.java
--- libraries/javalib/java/awt/ActionEvt.java	4 Jan 2002 05:12:19 -0000	1.6
+++ libraries/javalib/java/awt/ActionEvt.java	8 Jul 2004 12:08:58 -0000
@@ -1,5 +1,6 @@
 package java.awt;
 
+import kaffe.awt.Defaults;
 
 class ActionEvt
   extends java.awt.event.ActionEvent
Index: libraries/javalib/java/awt/AdjustmentEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/AdjustmentEvt.java,v
retrieving revision 1.5
diff -u -r1.5 AdjustmentEvt.java
--- libraries/javalib/java/awt/AdjustmentEvt.java	4 Jan 2002 05:12:19 -0000	1.5
+++ libraries/javalib/java/awt/AdjustmentEvt.java	8 Jul 2004 12:08:58 -0000
@@ -2,6 +2,8 @@
 
 import java.awt.event.AdjustmentEvent;
 
+import kaffe.awt.Defaults;
+
 class AdjustmentEvt
   extends AdjustmentEvent
 {
Index: libraries/javalib/java/awt/BarMenu.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/BarMenu.java,v
retrieving revision 1.9
diff -u -r1.9 BarMenu.java
--- libraries/javalib/java/awt/BarMenu.java	4 Jan 2002 05:12:19 -0000	1.9
+++ libraries/javalib/java/awt/BarMenu.java	8 Jul 2004 12:08:58 -0000
@@ -1,3 +1,13 @@
+/*
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ *
+ * @author P.C.Mehlitz
+ */
+
 package java.awt;
 
 import java.awt.event.KeyEvent;
@@ -7,15 +17,8 @@
 import java.awt.event.WindowAdapter;
 import java.awt.event.WindowEvent;
 
-/**
- * Copyright (c) 1998
- *    Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * @author P.C.Mehlitz
- */
+import kaffe.awt.Defaults;
+
 public class BarMenu
   extends Component
   implements ShortcutConsumer
Index: libraries/javalib/java/awt/Button.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Button.java,v
retrieving revision 1.2
diff -u -r1.2 Button.java
--- libraries/javalib/java/awt/Button.java	22 Mar 2004 11:24:34 -0000	1.2
+++ libraries/javalib/java/awt/Button.java	8 Jul 2004 12:08:58 -0000
@@ -1,3 +1,13 @@
+/*
+ * class Button -
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ */
+
 package java.awt;
 
 import java.awt.event.ActionEvent;
@@ -6,18 +16,10 @@
 import java.awt.event.KeyEvent;
 import java.awt.event.MouseEvent;
 
+import kaffe.awt.Defaults;
 import kaffe.awt.ImageDict;
 import kaffe.awt.ImageSpec;
 
-/**
- * class Button -
- *
- * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
 public class Button
   extends Component
   implements ShortcutConsumer
Index: libraries/javalib/java/awt/Checkbox.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Checkbox.java,v
retrieving revision 1.1
diff -u -r1.1 Checkbox.java
--- libraries/javalib/java/awt/Checkbox.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/Checkbox.java	8 Jul 2004 12:08:58 -0000
@@ -9,6 +9,8 @@
 import java.awt.event.MouseEvent;
 import java.awt.event.MouseListener;
 
+import kaffe.awt.Defaults;
+
 /**
  * class Checkbox - 
  *
Index: libraries/javalib/java/awt/CheckboxMenuItem.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/CheckboxMenuItem.java,v
retrieving revision 1.9
diff -u -r1.9 CheckboxMenuItem.java
--- libraries/javalib/java/awt/CheckboxMenuItem.java	16 Mar 2002 18:36:59 -0000	1.9
+++ libraries/javalib/java/awt/CheckboxMenuItem.java	8 Jul 2004 12:08:58 -0000
@@ -1,8 +1,3 @@
-package java.awt;
-
-import java.awt.event.ItemEvent;
-import java.awt.event.ItemListener;
-
 /**
  * CheckboxMenuItem
  *
@@ -13,6 +8,14 @@
  * of this file.
  * @author J.H.Mehlitz
  */
+
+package java.awt;
+
+import java.awt.event.ItemEvent;
+import java.awt.event.ItemListener;
+
+import kaffe.awt.Defaults;
+
 public class CheckboxMenuItem
   extends MenuItem
   implements ItemSelectable
Index: libraries/javalib/java/awt/Choice.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Choice.java,v
retrieving revision 1.1
diff -u -r1.1 Choice.java
--- libraries/javalib/java/awt/Choice.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/Choice.java	8 Jul 2004 12:08:59 -0000
@@ -1,3 +1,13 @@
+/*
+ * class Choice - 
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ */
+
 package java.awt;
 
 import java.awt.event.ActionEvent;
@@ -13,15 +23,8 @@
 import java.awt.event.WindowEvent;
 import java.util.Vector;
 
-/**
- * class Choice - 
- *
- * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+import kaffe.awt.Defaults;
+
 public class Choice
   extends Container
   implements ItemSelectable, ActionListener, ItemListener, MouseListener, KeyListener, FocusListener
Index: libraries/javalib/java/awt/Component.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Component.java,v
retrieving revision 1.31
diff -u -r1.31 Component.java
--- libraries/javalib/java/awt/Component.java	21 May 2004 12:29:08 -0000	1.31
+++ libraries/javalib/java/awt/Component.java	8 Jul 2004 12:08:59 -0000
@@ -26,6 +26,7 @@
 import java.util.Locale;
 
 import kaffe.awt.DoNothingPeer;
+import kaffe.awt.Defaults;
 import kaffe.util.Ptr;
 
 /**
Index: libraries/javalib/java/awt/ComponentEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/ComponentEvt.java,v
retrieving revision 1.7
diff -u -r1.7 ComponentEvt.java
--- libraries/javalib/java/awt/ComponentEvt.java	12 Oct 1999 02:29:38 -0000	1.7
+++ libraries/javalib/java/awt/ComponentEvt.java	8 Jul 2004 12:09:00 -0000
@@ -2,6 +2,8 @@
 
 import java.awt.event.ComponentEvent;
 
+import kaffe.awt.Defaults;
+
 class ComponentEvt
   extends ComponentEvent
 {
Index: libraries/javalib/java/awt/ContainerEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/ContainerEvt.java,v
retrieving revision 1.3
diff -u -r1.3 ContainerEvt.java
--- libraries/javalib/java/awt/ContainerEvt.java	23 Apr 1999 18:22:35 -0000	1.3
+++ libraries/javalib/java/awt/ContainerEvt.java	8 Jul 2004 12:09:00 -0000
@@ -2,6 +2,8 @@
 
 import java.awt.event.ContainerEvent;
 
+import kaffe.awt.Defaults;
+
 class ContainerEvt
   extends ContainerEvent
 {
Index: libraries/javalib/java/awt/Dialog.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Dialog.java,v
retrieving revision 1.10
diff -u -r1.10 Dialog.java
--- libraries/javalib/java/awt/Dialog.java	17 May 2003 17:30:10 -0000	1.10
+++ libraries/javalib/java/awt/Dialog.java	8 Jul 2004 12:09:00 -0000
@@ -1,17 +1,19 @@
-package java.awt;
-
-
-/**
+/*
  * Dialog - 
  *
  * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ *	Transvirtual Technologies, Inc.  All rights reserved.
  *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  *
  * @author P. Mehlitz
  */
+
+package java.awt;
+
+import kaffe.awt.Defaults;
+
 public class Dialog
   extends Frame
 {
Index: libraries/javalib/java/awt/EventQueue.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/EventQueue.java,v
retrieving revision 1.11
diff -u -r1.11 EventQueue.java
--- libraries/javalib/java/awt/EventQueue.java	23 May 2004 15:16:09 -0000	1.11
+++ libraries/javalib/java/awt/EventQueue.java	8 Jul 2004 12:09:00 -0000
@@ -1,9 +1,4 @@
-package java.awt;
-
-import java.awt.event.FocusEvent;
-import java.awt.event.PaintEvent;
-
-/**
+/*
  *
  * Copyright (c) 1998
  *   Transvirtual Technologies Inc.  All rights reserved.
@@ -12,6 +7,14 @@
  * of this file.
  * @author P.C.Mehlitz
  */
+
+package java.awt;
+
+import java.awt.event.FocusEvent;
+import java.awt.event.PaintEvent;
+
+import kaffe.awt.Defaults;
+
 public class EventQueue
 {
 	AWTEvent localQueue;
Index: libraries/javalib/java/awt/FileDialog.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/FileDialog.java,v
retrieving revision 1.5
diff -u -r1.5 FileDialog.java
--- libraries/javalib/java/awt/FileDialog.java	24 Mar 1999 01:14:37 -0000	1.5
+++ libraries/javalib/java/awt/FileDialog.java	8 Jul 2004 12:09:00 -0000
@@ -1,3 +1,15 @@
+/*
+ * FileDialog - 
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution 
+ * of this file. 
+ *
+ * @author J. Mehlitz
+ */
+
 package java.awt;
 
 import java.awt.event.ActionEvent;
@@ -8,17 +20,8 @@
 import java.io.FilenameFilter;
 import java.util.Vector;
 
-/**
- * FileDialog - 
- *
- * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution 
- * of this file. 
- *
- * @author J. Mehlitz
- */
+import kaffe.awt.Defaults;
+
 public class FileDialog
   extends Dialog
   implements ActionListener, ItemListener, FilenameFilter
Index: libraries/javalib/java/awt/FocusEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/FocusEvt.java,v
retrieving revision 1.6
diff -u -r1.6 FocusEvt.java
--- libraries/javalib/java/awt/FocusEvt.java	22 Nov 2001 06:21:05 -0000	1.6
+++ libraries/javalib/java/awt/FocusEvt.java	8 Jul 2004 12:09:00 -0000
@@ -3,6 +3,8 @@
 import java.awt.event.FocusEvent;
 import java.awt.event.WindowEvent;
 
+import kaffe.awt.Defaults;
+
 class FocusEvt
   extends FocusEvent
 {
Index: libraries/javalib/java/awt/Font.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Font.java,v
retrieving revision 1.15
diff -u -r1.15 Font.java
--- libraries/javalib/java/awt/Font.java	22 Mar 2004 11:24:34 -0000	1.15
+++ libraries/javalib/java/awt/Font.java	8 Jul 2004 12:09:00 -0000
@@ -1,11 +1,29 @@
+/*
+ * Font
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * Copyright (c) 2004
+ *	Kaffe.org contributors, see ChangeLog for details.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ */
+
 package java.awt;
 
 import java.awt.font.FontRenderContext;
 import java.awt.font.GlyphVector;
 import java.awt.peer.FontPeer;
+import java.io.InputStream;
+import java.io.IOException;
 import java.io.Serializable;
 import java.text.CharacterIterator;
+import java.util.Hashtable;
+import java.util.Properties;
 
+import kaffe.awt.Defaults;
 import kaffe.util.Ptr;
 
 /**
@@ -26,57 +44,44 @@
 	final public static int HANGING_BASELINE = 2;
 	final private static long serialVersionUID = -4206021311591459213L;
 
+	static Properties fontMap;
+
+static {
+	InputStream is = Font.class.getResourceAsStream( "font.properties");
+	fontMap = new Properties();
+
+	if ( is != null ){
+		try {
+			fontMap.load( is );
+		}
+		catch ( IOException x ) {}
+	}
+}
+
 public Font ( String fntName, int fntStyle, int fntSize ) {
+	Object v;
 	String spec;
+	int i;
 
-	name = fntName;
+	name = (fntName != null) ? fntName : "Default";
 	style = fntStyle;
 	size = fntSize;
 	
-	/* Translate a font name into the true font - we have a number
-	 * of aliases to deal with which are kept in java.awt.Defaults.
-	 * We no longer cache them since this means Default changes will
-	 * not be seen.  However to speed the comparision we intern the
-	 * search string so we can do simple pointer checks (since string
-	 * constants are interned by default).
+	/*
+	 * mapping the Java font name to a spec string by means of a 
+	 * font.properties resource
 	 */
-
-	name = name.intern();
-	if (name == "Default") {
-		spec = Defaults.FsDefault;
-	}
-	else if (name == "Monospaced") {
-		spec = Defaults.FsMonospaced;
-	}
-	else if (name == "SansSerif") {
-		spec = Defaults.FsSansSerif;
-	}
-	else if (name == "Serif") {
-		spec = Defaults.FsSerif;
-	}
-	else if (name == "Dialog") {
-		spec = Defaults.FsDialog;
-	}
-	else if (name == "DialogInput") {
-		spec = Defaults.FsDialogInput;
-	}
-	else if (name == "ZapfDingbats") {
-		spec = Defaults.FsZapfDingbats;
-	}
-	else if (name == "Helvetica") {
-		spec = Defaults.FsSansSerif;
-	}
-	else if (name == "TimesRoman") {
-		spec = Defaults.FsSerif;
-	}
-	else if (name == "Courier") {
-		spec = Defaults.FsMonospaced;
-	}
-	else {
-		spec = name;
+	if ( (spec = (String) fontMap.get( name)) == null ) {
+		spec = (String) fontMap.get( normalize( name ) );
+		if ( spec == null ) {
+			spec = name;
+		}
 	}
 
-	nativeData = Toolkit.fntInitFont( spec, style, size);
+	nativeData = Toolkit.fntInitFont( spec, style, size + Defaults.FontSizeOffset );
+	if ( nativeData == null ) {
+		throw new AWTError( "native Font init failed: " + this );
+	}
 }
 
 /**
@@ -211,6 +216,30 @@
 
 public boolean isPlain() {
 	return (style == 0);
+}
+
+static String normalize ( String name ) {
+	/*
+	 * Use the right name instead of cluttering the properties with 
+	 * all possible combinations.
+	 */
+	if ( "Monospaced".equalsIgnoreCase( name ) )
+		return "Monospaced";
+	if ( "SansSerif".equalsIgnoreCase( name ) )
+		return "SansSerif";
+	if ( "TimesRoman".equalsIgnoreCase( name ) )
+		return "TimesRoman";
+	if ( "sans serif".equalsIgnoreCase( name ) )
+		return "SansSerif";
+	if ( "times roman".equalsIgnoreCase( name ) )
+		return "TimesRoman";
+	if ( "Default".equalsIgnoreCase( name ) )
+		return "Default";
+	if ( "Courier".equalsIgnoreCase( name ) )
+		return "Courier";
+	if ( "Helvetica".equalsIgnoreCase( name ) )
+		return "Helvetica";
+	return name;
 }
 
 public String toString() {
Index: libraries/javalib/java/awt/FontMetrics.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/FontMetrics.java,v
retrieving revision 1.11
diff -u -r1.11 FontMetrics.java
--- libraries/javalib/java/awt/FontMetrics.java	22 Mar 2004 11:24:34 -0000	1.11
+++ libraries/javalib/java/awt/FontMetrics.java	8 Jul 2004 12:09:00 -0000
@@ -1,9 +1,12 @@
-/**
- * Component - abstract root of all widgets
+/*
+ * FontMatrics
  *
  * Copyright (c) 1998
  *    Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ *	Kaffe.org contributors, see ChangeLog for details.  All rights reserved.
+ *
  * See the file "license.terms" for information on usage and redistribution
  * of this file.
  *
@@ -14,19 +17,20 @@
 
 import java.util.Hashtable;
 
+import kaffe.awt.Defaults;
 import kaffe.util.Ptr;
 
 public class FontMetrics
   implements java.io.Serializable
 {
-        // We store the font because the font metrics
-        // depends on the native data maintained by the font
-        // in this way the original font object will not be
-        // finalized (and the native data freed).
-        // Note that since fontmetrics instances are cached
-        // their life span is higher than the Font object one.
-        // (Maurizio De Cecco maurizio@mandrakesoft.com).
-
+        /*
+	 * We store the font because the font metrics depends on the native data 
+	 * maintained by the font in this way the original font object will not 
+	 * be finalized (and the native data freed).
+	 * Note that since fontmetrics instances are cached their life span is 
+	 * higher than the Font object one.
+         * (Maurizio De Cecco maurizio@mandrakesoft.com).
+	 */
         Font font;  
 
 	transient Ptr nativeData;
@@ -105,7 +109,7 @@
 public int charsWidth ( char data[], int off, int len ) {
 	if ( fixedWidth != 0 ) {
 		return len*fixedWidth;
-  }
+	}
 	else if ( !isWideFont ) {
 		int i, w, n=off+len;
 		if ( widths == null ) {
@@ -144,12 +148,20 @@
 }
 
 static FontMetrics getFontMetrics ( Font font ) {
-	String key = font.encode();
-	FontMetrics metrics = (FontMetrics) cache.get( key);
-
-	if ( metrics == null ) {
-		metrics = new FontMetrics( font);
-		cache.put( key, metrics);
+	FontMetrics metrics = null;
+	if ( Defaults.CacheFontMetrics ) { 
+		String key = font.encode();
+		if ( cache == null ) {
+			cache = new Hashtable( 20 );
+		}
+		if ( (metrics = (FontMetrics) cache.get (key)) == null ) {
+			// cache missed: create new metrics & install in cache
+			cache.put(key, (metrics = new FontMetrics( font ) ) );
+		}
+	} 
+	else {
+		// not caching at all
+		metrics = new FontMetrics( font );
 	}
 
 	return metrics;
Index: libraries/javalib/java/awt/Frame.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Frame.java,v
retrieving revision 1.15
diff -u -r1.15 Frame.java
--- libraries/javalib/java/awt/Frame.java	17 May 2003 17:30:10 -0000	1.15
+++ libraries/javalib/java/awt/Frame.java	8 Jul 2004 12:09:00 -0000
@@ -1,8 +1,4 @@
-package java.awt;
-
-import java.awt.event.WindowEvent;
-
-/**
+/*
  * Frame - 
  *
  * Copyright (c) 1998
@@ -13,6 +9,13 @@
  *
  * @author P.C.Mehlitz
  */
+
+package java.awt;
+
+import java.awt.event.WindowEvent;
+
+import kaffe.awt.Defaults;
+
 public class Frame
   extends Window
 {
Index: libraries/javalib/java/awt/Image.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Image.java,v
retrieving revision 1.18
diff -u -r1.18 Image.java
--- libraries/javalib/java/awt/Image.java	7 Jul 2004 12:58:45 -0000	1.18
+++ libraries/javalib/java/awt/Image.java	8 Jul 2004 12:09:01 -0000
@@ -22,6 +22,7 @@
 import java.util.Hashtable;
 import java.util.Vector;
 
+import kaffe.awt.Defaults;
 import kaffe.util.Ptr;
 import kaffe.util.VectorSnapshot;
 
Index: libraries/javalib/java/awt/ImageNativeProducer.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/ImageNativeProducer.java,v
retrieving revision 1.4
diff -u -r1.4 ImageNativeProducer.java
--- libraries/javalib/java/awt/ImageNativeProducer.java	22 Mar 2004 11:24:34 -0000	1.4
+++ libraries/javalib/java/awt/ImageNativeProducer.java	8 Jul 2004 12:09:01 -0000
@@ -1,3 +1,13 @@
+/**
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ *
+ * @author P.C.Mehlitz
+ */
+
 package java.awt;
 
 import java.awt.image.ColorModel;
@@ -10,18 +20,10 @@
 import java.net.URLConnection;
 import java.util.Vector;
 
+import kaffe.awt.Defaults;
 import kaffe.io.AccessibleBAOStream;
 import kaffe.util.Ptr;
 
-/**
- * Copyright (c) 1998
- *    Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * @author P.C.Mehlitz
- */
 class ImageNativeProducer
   implements ImageProducer
 {
Index: libraries/javalib/java/awt/ItemEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/ItemEvt.java,v
retrieving revision 1.4
diff -u -r1.4 ItemEvt.java
--- libraries/javalib/java/awt/ItemEvt.java	24 Jul 1999 00:56:12 -0000	1.4
+++ libraries/javalib/java/awt/ItemEvt.java	8 Jul 2004 12:09:01 -0000
@@ -2,6 +2,8 @@
 
 import java.awt.event.ItemEvent;
 
+import kaffe.awt.Defaults;
+
 class ItemEvt
   extends ItemEvent
 {
Index: libraries/javalib/java/awt/KeyEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/KeyEvt.java,v
retrieving revision 1.8
diff -u -r1.8 KeyEvt.java
--- libraries/javalib/java/awt/KeyEvt.java	23 May 2004 15:16:09 -0000	1.8
+++ libraries/javalib/java/awt/KeyEvt.java	8 Jul 2004 12:09:01 -0000
@@ -2,6 +2,8 @@
 
 import java.awt.event.KeyEvent;
 
+import kaffe.awt.Defaults;
+
 class KeyEvt
   extends KeyEvent
 {
Index: libraries/javalib/java/awt/Label.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Label.java,v
retrieving revision 1.1
diff -u -r1.1 Label.java
--- libraries/javalib/java/awt/Label.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/Label.java	8 Jul 2004 12:09:01 -0000
@@ -1,4 +1,4 @@
-/**
+/*
  * class Label - 
  *
  * Copyright (c) 1998
@@ -10,6 +10,7 @@
 
 package java.awt;
 
+import kaffe.awt.Defaults;
 
 public class Label
   extends Component
Index: libraries/javalib/java/awt/List.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/List.java,v
retrieving revision 1.1
diff -u -r1.1 List.java
--- libraries/javalib/java/awt/List.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/List.java	8 Jul 2004 12:09:01 -0000
@@ -12,6 +12,8 @@
 import java.util.BitSet;
 import java.util.Vector;
 
+import kaffe.awt.Defaults;
+
 /**
  * class List -
  *
Index: libraries/javalib/java/awt/MenuComponent.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/MenuComponent.java,v
retrieving revision 1.10
diff -u -r1.10 MenuComponent.java
--- libraries/javalib/java/awt/MenuComponent.java	12 Jul 2002 12:35:22 -0000	1.10
+++ libraries/javalib/java/awt/MenuComponent.java	8 Jul 2004 12:09:01 -0000
@@ -2,6 +2,9 @@
 
 import java.awt.peer.MenuComponentPeer;
 
+import kaffe.awt.Defaults;
+
+
 /**
  * Copyright (c) 1998
  *    Transvirtual Technologies, Inc.  All rights reserved.
Index: libraries/javalib/java/awt/MenuItem.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/MenuItem.java,v
retrieving revision 1.12
diff -u -r1.12 MenuItem.java
--- libraries/javalib/java/awt/MenuItem.java	16 Mar 2002 18:36:59 -0000	1.12
+++ libraries/javalib/java/awt/MenuItem.java	8 Jul 2004 12:09:01 -0000
@@ -1,20 +1,23 @@
-package java.awt;
-
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.util.Vector;
-
-/**
+/*
  * class MenuItem -
  *
  * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ *	Transvirtual Technologies, Inc.  All rights reserved.
  *
  * See the file "license.terms" for information on usage and redistribution
  * of this file.
  *
  * @author J.Mehlitz
  */
+
+package java.awt;
+
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.util.Vector;
+
+import kaffe.awt.Defaults;
+
 public class MenuItem
   extends MenuComponent
   implements ShortcutConsumer
Index: libraries/javalib/java/awt/MouseEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/MouseEvt.java,v
retrieving revision 1.9
diff -u -r1.9 MouseEvt.java
--- libraries/javalib/java/awt/MouseEvt.java	23 May 2004 15:16:09 -0000	1.9
+++ libraries/javalib/java/awt/MouseEvt.java	8 Jul 2004 12:09:02 -0000
@@ -3,6 +3,8 @@
 import java.awt.event.MouseEvent;
 import java.util.Stack;
 
+import kaffe.awt.Defaults;
+
 /**
  *
  * Copyright (c) 1998
Index: libraries/javalib/java/awt/PSGraphics.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/PSGraphics.java,v
retrieving revision 1.5
diff -u -r1.5 PSGraphics.java
--- libraries/javalib/java/awt/PSGraphics.java	7 Jul 2004 12:58:46 -0000	1.5
+++ libraries/javalib/java/awt/PSGraphics.java	8 Jul 2004 12:09:02 -0000
@@ -24,6 +24,8 @@
 import java.io.PrintStream;
 import java.util.Hashtable;
 
+import kaffe.awt.Defaults;
+
 public class PSGraphics
   extends Graphics
   implements PrintGraphics
Index: libraries/javalib/java/awt/RowCanvas.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/RowCanvas.java,v
retrieving revision 1.1
diff -u -r1.1 RowCanvas.java
--- libraries/javalib/java/awt/RowCanvas.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/RowCanvas.java	8 Jul 2004 12:09:02 -0000
@@ -8,6 +8,8 @@
 import java.awt.event.MouseEvent;
 import java.util.Vector;
 
+import kaffe.awt.Defaults;
+
 /**
  * class RowCanvas -
  *
Index: libraries/javalib/java/awt/ScrollPane.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/ScrollPane.java,v
retrieving revision 1.13
diff -u -r1.13 ScrollPane.java
--- libraries/javalib/java/awt/ScrollPane.java	24 Nov 2001 01:52:43 -0000	1.13
+++ libraries/javalib/java/awt/ScrollPane.java	8 Jul 2004 12:09:02 -0000
@@ -1,19 +1,22 @@
-package java.awt;
-
-import java.awt.event.AdjustmentEvent;
-import java.awt.event.AdjustmentListener;
-
-/**
+/*
  * ScrollPane - widget for scrolling a child component
  *
  * Copyright (c) 1998
- *    Transvirtual Technologies, Inc.  All rights reserved.
+ *	Transvirtual Technologies, Inc.  All rights reserved.
  *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  *
  * @author P.C.Mehlitz
  */
+
+package java.awt;
+
+import java.awt.event.AdjustmentEvent;
+import java.awt.event.AdjustmentListener;
+
+import kaffe.awt.Defaults;
+
 public class ScrollPane
   extends Container
   implements AdjustmentListener
Index: libraries/javalib/java/awt/Scrollbar.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Scrollbar.java,v
retrieving revision 1.2
diff -u -r1.2 Scrollbar.java
--- libraries/javalib/java/awt/Scrollbar.java	22 Mar 2004 11:24:34 -0000	1.2
+++ libraries/javalib/java/awt/Scrollbar.java	8 Jul 2004 12:09:02 -0000
@@ -6,6 +6,7 @@
 import java.awt.event.MouseListener;
 import java.awt.event.MouseMotionListener;
 
+import kaffe.awt.Defaults;
 import kaffe.util.Timer;
 import kaffe.util.TimerClient;
 
Index: libraries/javalib/java/awt/TextArea.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/TextArea.java,v
retrieving revision 1.1
diff -u -r1.1 TextArea.java
--- libraries/javalib/java/awt/TextArea.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/TextArea.java	8 Jul 2004 12:09:03 -0000
@@ -1,3 +1,14 @@
+/**
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ *
+ * @author J.Mehlitz
+ */
+
 package java.awt;
 
 import java.awt.event.FocusEvent;
@@ -9,16 +20,8 @@
 import java.awt.event.MouseMotionListener;
 import java.util.Vector;
 
-/**
- *
- * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * @author J.Mehlitz
- */
+import kaffe.awt.Defaults;
+
 public class TextArea
   extends TextComponent
 {
Index: libraries/javalib/java/awt/TextComponent.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/TextComponent.java,v
retrieving revision 1.1
diff -u -r1.1 TextComponent.java
--- libraries/javalib/java/awt/TextComponent.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/TextComponent.java	8 Jul 2004 12:09:03 -0000
@@ -1,3 +1,13 @@
+/**
+ * class TextComponent - 
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ */
+
 package java.awt;
 
 import java.awt.datatransfer.Clipboard;
@@ -10,15 +20,8 @@
 import java.awt.event.TextEvent;
 import java.awt.event.TextListener;
 
-/**
- * class TextComponent - 
- *
- * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+import kaffe.awt.Defaults;
+
 abstract public class TextComponent
   extends Container
   implements ActionListener
Index: libraries/javalib/java/awt/TextCursor.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/TextCursor.java,v
retrieving revision 1.1
diff -u -r1.1 TextCursor.java
--- libraries/javalib/java/awt/TextCursor.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/TextCursor.java	8 Jul 2004 12:09:03 -0000
@@ -1,5 +1,6 @@
 package java.awt;
 
+import kaffe.awt.Defaults;
 
 public class TextCursor
 {
Index: libraries/javalib/java/awt/TextEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/TextEvt.java,v
retrieving revision 1.2
diff -u -r1.2 TextEvt.java
--- libraries/javalib/java/awt/TextEvt.java	24 Jul 1999 00:56:13 -0000	1.2
+++ libraries/javalib/java/awt/TextEvt.java	8 Jul 2004 12:09:03 -0000
@@ -2,6 +2,8 @@
 
 import java.awt.event.TextEvent;
 
+import kaffe.awt.Defaults;
+
 class TextEvt
   extends java.awt.event.TextEvent
 {
Index: libraries/javalib/java/awt/TextField.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/TextField.java,v
retrieving revision 1.1
diff -u -r1.1 TextField.java
--- libraries/javalib/java/awt/TextField.java	12 Aug 2003 17:02:26 -0000	1.1
+++ libraries/javalib/java/awt/TextField.java	8 Jul 2004 12:09:03 -0000
@@ -1,3 +1,13 @@
+/*
+ * class TextField - 
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file.
+ */
+
 package java.awt;
 
 import java.awt.event.ActionEvent;
@@ -11,15 +21,8 @@
 import java.awt.event.MouseListener;
 import java.awt.event.MouseMotionListener;
 
-/**
- * class TextField - 
- *
- * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+import kaffe.awt.Defaults;
+
 public class TextField
   extends TextComponent
   implements MouseMotionListener, KeyListener, FocusListener, MouseListener
Index: libraries/javalib/java/awt/Toolkit.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Toolkit.java,v
retrieving revision 1.18
diff -u -r1.18 Toolkit.java
--- libraries/javalib/java/awt/Toolkit.java	21 May 2004 12:29:08 -0000	1.18
+++ libraries/javalib/java/awt/Toolkit.java	8 Jul 2004 12:09:04 -0000
@@ -1,3 +1,21 @@
+/*
+ * Toolkit - used to be an abstract factory for peers, but since we don't have
+ * peers, it is just a simple anchor for central mechanisms (like System-
+ * EventQueue etc.) and a wrapper for all native methods. Of course, it is a
+ * singleton.
+ *
+ * Copyright (c) 1998
+ *	Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * Copyright (c) 2004
+ *	Kaffe.org contributors, see ChangeLog for details.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution 
+ * of this file. 
+ *
+ * @author P.C.Mehlitz
+ */
+
 package java.awt;
 
 import java.awt.datatransfer.Clipboard;
@@ -17,25 +35,12 @@
 import java.net.URL;
 import java.util.Properties;
 
+import kaffe.awt.Defaults;
 import kaffe.awt.DoNothingPeer;
 import kaffe.util.Ptr;
 import kaffe.util.log.LogClient;
 import kaffe.util.log.LogStream;
 
-/**
- * Toolkit - used to be an abstract factory for peers, but since we don't have
- * peers, it is just a simple anchor for central mechanisms (like System-
- * EventQueue etc.) and a wrapper for all native methods. Of course, it is a
- * singleton.
- *
- * Copyright (c) 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution 
- * of this file. 
- *
- * @author P.C.Mehlitz
- */
 class FlushThread
   extends Thread
 {
@@ -46,7 +51,7 @@
 	super( "AWT-Flusher");
 	
 	flushInterval = interval;
-	setPriority( Thread.MIN_PRIORITY + 1);
+	setPriority( Toolkit.eventThread.getPriority() );
 }
 
 public void run () {
@@ -78,8 +83,14 @@
 	// layer before falling into its dispatcher loop
 
 	try {
-		if ( !Toolkit.tlkInit( System.getProperty( "awt.display")) ) {
-			throw new AWTError( "native layer init failed");
+		// most of the native init probably goes in, here (even though we
+		// still have tlkInit() called, but in the wrong thread)
+		if ( !Toolkit.tlkInit( System.getProperty( "awt.display" ) ) ) {
+			throw new AWTError( "native layer init failed" );
+		}
+		// wake up the Toolkit.clinit
+		synchronized ( this ) {
+			notifyAll();
 		}
 	} catch ( Throwable x ) {
 		x.printStackTrace();
Index: libraries/javalib/java/awt/Window.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/Window.java,v
retrieving revision 1.19
diff -u -r1.19 Window.java
--- libraries/javalib/java/awt/Window.java	22 Mar 2004 11:24:35 -0000	1.19
+++ libraries/javalib/java/awt/Window.java	8 Jul 2004 12:09:04 -0000
@@ -5,6 +5,7 @@
 import java.awt.event.WindowListener;
 import java.awt.peer.ComponentPeer;
 
+import kaffe.awt.Defaults;
 import kaffe.util.Ptr;
 
 /**
Index: libraries/javalib/java/awt/WindowEvt.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/awt/WindowEvt.java,v
retrieving revision 1.6
diff -u -r1.6 WindowEvt.java
--- libraries/javalib/java/awt/WindowEvt.java	12 Oct 1999 02:29:41 -0000	1.6
+++ libraries/javalib/java/awt/WindowEvt.java	8 Jul 2004 12:09:04 -0000
@@ -2,6 +2,8 @@
 
 import java.awt.event.WindowEvent;
 
+import kaffe.awt.Defaults;
+
 class WindowEvt
   extends WindowEvent
 {
Index: libraries/javalib/profiles/allatonce/all.files
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/profiles/allatonce/all.files,v
retrieving revision 1.50
diff -u -r1.50 all.files
--- libraries/javalib/profiles/allatonce/all.files	3 Jun 2004 18:56:14 -0000	1.50
+++ libraries/javalib/profiles/allatonce/all.files	8 Jul 2004 12:09:06 -0000
@@ -395,7 +395,6 @@
 java/awt/datatransfer/SystemFlavorMap.java
 java/awt/datatransfer/Transferable.java
 java/awt/datatransfer/UnsupportedFlavorException.java
-java/awt/Defaults.java
 java/awt/DefKeyFilter.java
 java/awt/Dialog.java
 java/awt/Dimension.java
@@ -1480,6 +1479,7 @@
 kaffe/awt/ObjectSelection.java
 kaffe/awt/OpaqueComponent.java
 kaffe/awt/SerializerConverter.java
+kaffe/awt/Defaults.java
 kaffe/beans/editors/BooleanEditor.java
 kaffe/beans/editors/ByteEditor.java
 kaffe/beans/editors/DoubleEditor.java
Index: libraries/javalib/profiles/default/coreawt.files
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/profiles/default/coreawt.files,v
retrieving revision 1.9
diff -u -r1.9 coreawt.files
--- libraries/javalib/profiles/default/coreawt.files	23 May 2004 13:23:29 -0000	1.9
+++ libraries/javalib/profiles/default/coreawt.files	8 Jul 2004 12:09:06 -0000
@@ -36,7 +36,6 @@
 java/awt/datatransfer/SystemFlavorMap.java
 java/awt/datatransfer/Transferable.java
 java/awt/datatransfer/UnsupportedFlavorException.java
-java/awt/Defaults.java
 java/awt/Dimension.java
 java/awt/DisplayMode.java
 java/awt/dnd/DnDConstants.java
@@ -220,5 +219,6 @@
 kaffe/awt/MouseHook.java
 kaffe/awt/ObjectSelection.java
 kaffe/awt/SerializerConverter.java
+kaffe/awt/Defaults.java
 kaffe/util/log/LogClient.java
 kaffe/util/log/LogStream.java
--- /dev/null	2004-06-02 13:06:52.000000000 +0800
+++ libraries/javalib/kaffe/awt/Defaults.java	2004-07-08 19:57:07.000000000 +0800
@@ -0,0 +1,580 @@
+/*
+ * Defaults - adaption parameters of package java.awt. This is our way to
+ * parameterize various settings like colors and fonts. We prefer a simple
+ * Java class (in favor of properties) because it doesn't need extra file
+ * system access, is much faster, more robust (no parsing, compile time check),
+ * and can be overridden by simply extending the CLASSPATH (no jar archive
+ * modification).
+ *
+ * Be very carefully to add additional java.awt types, since this might
+ * introduce recursive class init problems. This is especially
+ * true if static fields of such classes are involved (like Color), since
+ * they might be still "null" (if they in turn refer to Toolkit/Defaults)
+ * when referenced inside of this class.
+ *
+ * Copyright (c) 1998
+ *      Transvirtual Technologies, Inc.  All rights reserved.
+ *
+ * See the file "license.terms" for information on usage and redistribution 
+ * of this file. 
+ *
+ * @author P.C.Mehlitz
+ */
+
+package kaffe.awt;
+        
+import java.awt.Color;
+import java.awt.Dimension;
+import java.awt.Font;
+import java.awt.FontMetrics;
+import java.awt.Insets;
+import java.awt.Toolkit;
+import java.util.Hashtable;
+
+public class Defaults
+{
+	/*
+	 * If this is set to a valid classname, the corresponding class will be used to
+	 * instanciate the event queue. Note that this class should be derived from
+	 * java.awt.EventQueue in order to enable things like repaint solicitation.
+	 *
+	 * Due to a JDK bug, this field has to be the first one, to avoid recursive
+	 * initialization problems (not relevant for kaffe)
+	 */
+	public static String EventQueueClass = setStringValue( "awt.EventQueueClass", null );
+
+	/*
+	 * If ConsoleClass is set to the classname of a kaffe.util.log.LogClient, System.out, err
+	 * are redirected to a kaffe.util.log.LogStream, which notifies the provided LogClient
+	 * (usually a simple Window displaying scrolled text). If ConsoleClass is null, no
+	 * io redirection is performed.
+	 */
+	public static String ConsoleClass = null;
+
+	/*
+	 * If set to 'true', the last Window that is closed will automatically
+	 * call a System.exit()
+	 */
+	public static boolean AutoStop = setBooleanValue( "awt.AutoStop", true );
+
+	/*
+	 * Upper bound (in ms) between mouse button press events which will be
+	 * considered as a 'click' (will increase the MouseEvent clickCount)
+	 */
+	public static int ClickInterval = 250;
+
+	/*
+	 * maximum x,y coordinate distance (in pixels) between successive MOUSE_PRESSED
+	 * events which are still considered to be a click (required for some devices
+	 * without exact mouse positioning).
+	 */
+	public static int ClickDistance = 0;
+
+	/*
+	 * Sleep time (in ms) between native getNextEvent calls (= event polling rate).
+	 * Just used in case the native layer does not support blocked IO.
+	 */
+	public static int EventPollingRate = 30;
+
+	/*
+	 * Delay (in ms) between background native flush calls (from the flush thread) in case
+	 * the native layer needs flushing (queued graphics systems like X). This is only
+	 * required for apps doing graphics output outside the event dispatch thread, and for
+	 * native layers doing blocked IO (in this case the background drawing wouldn't appear
+	 * until something is going on in the dispatcher thread)
+	 */
+	public static int GraFlushRate = setIntValue( "awt.GraFlushRate", 250 );
+
+	/*
+	 * Physical screen size in 1/10 inches (used for scaling purposes, e.g. fr printing)
+	 */
+	public static int ScreenSize = 130;
+
+	/*
+	 * just a shadow from the Defaults screen width (computed by the native layer)
+	 */
+	public static int ScreenWidth;
+
+	/*
+	 * screen resolution (in dpi), to be used for printing
+	 */
+	public static int XResolution;
+
+	/*
+	 * screen resolution (in dpi), to be used for printing
+	 */
+	public static int YResolution;
+
+	/*
+	 * Pixel height of MenuBars
+	 */
+	public static int MenuBarHeight;
+	public static int ScrollbarWidth = 14;
+
+	/*
+	 * Frame decoration extends (titlebar, size-borders) in pixels. For native windowing
+	 * systems (like X) this is just a guess, to be used for the first Frame to be opened,
+	 * and later on corrected (Frame.frameDeco). For standalone envionments, this is
+	 * an order
+	 */
+	public static Insets FrameInsets = new Insets( 24, 4, 4, 4 );
+
+	/*
+	 * Dialog decoration extends (titlebar, size-borders) in pixels. For native windowing
+	 * systems (like X) this is just a guess, to be used for the first Dialog to be opened,
+	 * and later on corrected (Dialog.dialogDeco). For standalone envionments, this is
+	 * an order
+	 */
+	public static Insets DialogInsets = new Insets( 24, 4, 4, 4 );
+
+	/*
+	 * Color used to mark the focus Component (border)
+	 */
+	public static Color FocusClr = new Color( 191, 0, 0 );
+
+	/*
+	 * Default foreground color for Windows
+	 */
+	public static Color WndForeground = Color.black;
+
+	/*
+	 * Default background color for Windows
+	 */
+	public static Color WndBackground = Color.lightGray;
+
+	/*
+	 * Default font for Windows
+	 */
+	public static Font WndFont;
+
+	/*
+	 * metrics of the WndFont (computed)
+	 */
+	public static FontMetrics WndFontMetrics;
+
+	/*
+	 * Default font for menus
+	 */
+	public static Font MenuFont;
+
+	/*
+	 * Default text color for menus
+	 */
+	public static Color MenuTxtClr = Color.black;
+
+	/*
+	 * Text color of selected meu item
+	 */
+	public static Color MenuSelTxtClr = FocusClr;
+
+	/*
+	 * Default background color for menus
+	 */
+	public static Color MenuBgClr = Color.lightGray;
+	public static Color MenuSelBgClr = new Color( 180, 180, 180 );
+
+	/*
+	 * If set to 'true', menu text will be drawn "carved" (with a down-right highlight)
+	 */
+	public static boolean MenuTxtCarved = true;
+
+	/*
+	 * Default text font
+	 */
+	public static Font TextFont;
+
+	/*
+	 * Default TextArea background color
+	 */
+	public static Color TextAreaBgClr = Color.white;
+
+	/*
+	 * Default TextArea text color
+	 */
+	public static Color TextAreaTxtClr = Color.black;
+	public static Color TextAreaRoBgClr = Color.white;
+
+	/*
+	 * text color of non-editable TextComponents
+	 */
+	public static Color TextAreaRoTxtClr = Color.gray;
+
+	/*
+	 * Default TextArea font
+	 */
+	public static Font TextAreaFont;
+
+	/*
+	 * Default TextArea selection background color
+	 */
+	public static Color TextAreaSelBgClr = Color.lightGray;
+
+	/*
+	 * Default TextArea selection text color
+	 */
+	public static Color TextAreaSelTxtClr = Color.black;
+
+	/*
+	 * TextArea focus cursor color
+	 */
+	public static Color TextCursorClr = Color.blue;
+
+	/*
+	 * TextArea inactive (non-focus) cursor color
+	 */
+	public static Color TextCursorInactiveClr = Color.gray;
+
+	/*
+	 * If set to 'true', non-focused TextAreas keep their cursor displayed (in inactive color)
+	 */
+	public static boolean ShowInactiveCursor = false;
+
+	/*
+	 * If set to 'true', ScrollBars can get focus
+	 */
+	public static boolean FocusScrolls = false;
+
+	/*
+	 * Default TextField background color
+	 */
+	public static Color TextFieldBgClr = Color.white;
+
+	/*
+	 * Default TextField text color
+	 */
+	public static Color TextFieldTxtClr = Color.black;
+
+	/*
+	 * Default TextField selection background color
+	 */
+	public static Color TextFieldSelBgClr = Color.lightGray;
+
+	/*
+	 * Default TextField text color
+	 */
+	public static Color TextFieldSelTxtClr = Color.black;
+
+	/*
+	 * Default TextField font
+	 */
+	public static Font TextFieldFont;
+
+	/*
+	 * Default List font
+	 */
+	public static Font ListFont;
+
+	/*
+	 * Default List background color
+	 */
+	public static Color ListBgClr = new Color( 223, 223, 223 );
+
+	/*
+	 * Default Lis text color
+	 */
+	public static Color ListTxtClr = Color.black;
+
+	/*
+	 * List selection background color
+	 */
+	public static Color ListSelBgClr = new Color( 0xa3a3a3 );
+
+	/*
+	 * List selection text color
+	 */
+	public static Color ListSelTxtClr = Color.black;
+
+	/*
+	 * List fly-over background color (item under mouse pointer)
+	 */
+	public static Color ListFlyOverBgClr = new Color( 214, 214, 214 );
+
+	/*
+	 * List fly-over text color (item under mouse pointer)
+	 */
+	public static Color ListFlyOverTxtClr = Color.black;
+
+	/*
+	 * If set to 'true', fly-over items will be drawn with an inset border
+	 * (outset otherwise)
+	 */
+	public static boolean ListFlyOverInset = false;
+
+	/*
+	 * fire action command on click instead of dblClick ( e.g. touchscreen devices )
+	 */
+	public static boolean ListClickAction = false;
+
+	/*
+	 * Default Label text color
+	 */
+	public static Color LabelClr = Color.black;
+
+	/*
+	 * Default Label font
+	 */
+	public static Font LabelFont;
+
+	/*
+	 * If set to 'true', Label text will be drawn carved (with right-down highlight)
+	 */
+	public static boolean LabelTxtCarved = false;
+
+	/*
+	 * Default background color for Buttons
+	 */
+	public static Color BtnClr = new Color( 0xa3a3a3 );
+	public static boolean BtnAnimation = true;
+
+	/*
+	 * Default text color for Buttons
+	 */
+	public static Color BtnTxtClr = Color.black;
+
+	/*
+	 * Button background color if button is under mouse pointer
+	 */
+	public static Color BtnPointClr = new Color( 180, 180, 180 );
+
+	/*
+	 * Button text color if button is under mouse pointer
+	 */
+	public static Color BtnPointTxtClr = FocusClr;
+
+	/*
+	 * Default font for Buttons
+	 */
+	public static Font BtnFont;
+
+	/*
+	 * If set to 'true', Button text will be drawn carved (with right-down highlight)
+	 */
+	public static boolean BtnTxtCarved = true;
+
+	/*
+	 * Color for Component borders
+	 */
+	public static Color BorderClr = new Color( 159, 159, 159 );
+
+	/**
+	 * Color for active window borders (only used in standalone environments)
+	 */
+	public static Color WndActiveClr = new Color( 191, 0, 0 );
+
+	/*
+	 * Color for active window titlebar background (only used in standalone environments)
+	 */
+	public static Color WndActiveTitleClr = Color.yellow;
+
+	/*
+	 * Color for inactive window borders (only for standalone environments)
+	 */
+	public static Color WndInactiveClr = Color.lightGray;
+
+	/*
+	 * Color for inactive window titlebar background (only used in standalone environments)
+	 */
+	public static Color WndInactiveTitleClr = Color.black;
+
+	/*
+	 * Maximum size of image files to be produced immediately (when the corrseponding
+	 * image is created). Images with files exceeding this size will be produced
+	 * asynchronously on demand
+	 */
+	public static int FileImageThreshold = setIntValue( "awt.FileImageThreshold", 0xffff );
+
+	/*
+	 * Maximum size of image data buffers to be produced immediately (when the corrseponding
+	 * image is created). Images with data buffers exceeding this size will be produced
+	 * asynchronously on demand
+	 */
+	public static int DataImageThreshold = setIntValue( "awt.DataImageThreshold", 0xffff );
+
+	/*
+	 * Maximum size of MemoryImageSource data to be produced immediately (when the
+	 * corrseponding image is created). Images with data buffers exceeding this
+	 * size will be produced asynchronously on demand (currently, everything != 0
+	 * will cause async production)
+	 */
+	public static int MemImageSrcThreshold = setIntValue( "awt.MemImageSrcThreshold", 0xffff );
+
+	/*
+	 * AWT events are usually short lived objects created with high frequency (mouse motion).
+	 * Since creation and destruction are usually in control of the AWT innards
+	 * (EventDispatchThread), they are good candidates for class local caching. Mostly. Some
+	 * apps really store events when processing them (mostly as a quick&dirty way to save state).
+	 * In case we have such a beast, turn off the xx_EVENT_MASK bit for this event type in
+	 * 'RecycleEvents'. A value of '0' means there is no caching at all, a value of 0xffffffff
+	 * caches everything.
+	 */
+	public static int RecycleEvents = 0xffffffff;
+
+	/*
+	 * Name of RootWindow (screen) class. Only used in standalone environments
+	 */
+	public static String RootWindowClass = "java.awt.RootWindow";
+
+	/*
+	 * Background color for RootWindow (stand-alone environments only)
+	 */
+	public static Color RootWindowClr = setColorValue( "awt.RootWindowClr", Color.blue );
+
+	/*
+	 * Image filename to be used to tile RootWindow background (only for standalone environments)
+	 */
+	public static String RootWindowImg = setStringValue( "awt.RootWindowImg", null );
+
+	/*
+	 * Name of class to be used to control desktop pages and controls (only for
+	 * standalone environments)
+	 */
+	public static String ControlBoxClass = setStringValue( "awt.ControlBox", "java.awt.WinTaskBar" );
+
+	/*
+	 * Name of class to be used to display and control minimized windows (only for
+	 * standalone environments)
+	 */
+	public static String MinBoxClass = setStringValue( "awt.MinBox", "java.awt.WinTaskBar" );
+
+	/*
+	 * Name of the file to load as the startup banner.
+	 */
+	public static String banner;
+
+	/*
+	 * Name of the file to play when we need to 'beep'
+	 */
+	public static String beep;
+	public static String UserInitClass = setStringValue( "awt.UserInitClass", null );
+
+	/*
+	 * The actual font size depends not just on the point size, but also the screen
+	 * (resolution/size). 'FontSizeOffset' can be used to adapt this (e.g. a value
+	 * of '-1' means a font which is requested in Java with point size X, is actually
+	 * created for size X-1 in the native layer)
+	 */
+	public static int FontSizeOffset = setIntValue( "awt.FontSizeOffset", 0 );
+
+	/*
+	 * Depending on the native font representation, font metrics objects can be quite
+	 * expensive (in terms of size and initialization). If an app uses them as temporary objects,
+	 * it therefore might be a good idea to cache them, which is done by setting 'CacheFontMetrics'
+	 * to 'true'. However, if an app uses a lot of them, and caches non-temporary metrics anyway,
+	 * it might also be a great waste of memory
+	 */
+	public static boolean CacheFontMetrics = setBooleanValue( "awt.CacheFontMetrics", true );
+
+	public static int SysFontHeight;
+
+	/*
+	 * just a shadow from the Defaults screen height (computed by the native layer)
+	 */
+	public static int ScreenHeight;
+
+	static {
+		Toolkit tk = Toolkit.getDefaultToolkit();
+
+		// these are the values we get back from the native init
+		Dimension sd = tk.getScreenSize();
+
+		ScreenWidth  = sd.width;
+		ScreenHeight = sd.height;
+
+		// we assume a 4:3 width/height ratio of the display
+		XResolution = (ScreenWidth  * 100 + 50) / (8 * ScreenSize); // dpi
+		YResolution = (ScreenHeight * 100 + 50) / (6 * ScreenSize); // dpi
+
+		WndFont = new Font( "Default", Font.BOLD, 11 );
+		MenuFont = new Font( "Default", Font.BOLD, 11 );
+		TextFont = new Font( "Default", Font.BOLD, 11 );
+		TextAreaFont = new Font( "Monospaced", Font.PLAIN, 11 );
+		TextFieldFont = new Font( "Default", Font.BOLD, 11 );
+		ListFont = new Font( "Default", Font.BOLD, 11 );
+		LabelFont = new Font( "Default", Font.PLAIN, 11 );
+		BtnFont = new Font( "Default", Font.BOLD, 11 );
+
+		WndFontMetrics = tk.getFontMetrics( WndFont );
+
+		SysFontHeight = WndFontMetrics.getHeight();
+
+		if ( MenuBarHeight == 0 ){
+			/*
+			 * Assume this is something like the "system font", which is 
+			 * a synonym for the TitlebarHeight (alternatively, we could 
+			 * use the MenuFont itself)
+			 */
+			MenuBarHeight = WndFontMetrics.getHeight() + 8;
+		}
+
+		beep = System.getProperty( "awt.beep", "beep.wav" );
+
+		if ( UserInitClass != null ) {
+			try {
+				Class asc = Class.forName( UserInitClass);
+			}
+			catch ( Exception x ) {
+				System.err.println( "UserInitClass not initialized: " + x );
+			}
+		}
+	}
+
+	static boolean setBooleanValue ( String propKey, boolean defValue ) {
+		boolean val;
+
+		String s = System.getProperty( propKey );
+		if ( s != null ) {
+			val = s.equalsIgnoreCase( "true" );
+		}
+		else {	
+			val = defValue;
+		}
+
+		return val;
+	}
+
+	static Color setColorValue ( String propKey, Color defValue ) {
+		Color val = defValue;
+
+		String s = System.getProperty( propKey );
+		if ( s != null ) {
+			try {
+				val = new Color( Integer.parseInt( s, 16 ) );
+			}
+			catch ( NumberFormatException x ) {
+				System.err.println( "malformed awt property: " + propKey );
+			}
+			s = null;
+		}
+
+		return val;
+	}
+
+	static int setIntValue ( String propKey, int defValue ) {
+		int val = defValue;
+
+		String s = System.getProperty( propKey );
+		if ( s != null ) {
+			try {
+				val = Integer.parseInt( s);
+			}
+			catch ( NumberFormatException x ) {
+				System.err.println( "malformed awt property: " + propKey );
+			}
+			s = null;
+		}
+		return val;
+	}
+
+	static String setStringValue ( String propKey, String defValue ) {
+		String val = System.getProperty( propKey );
+		if ( val == null ) {
+			val = defValue;
+		}
+		if ( "null".equals( val ) ) {
+			val = null;
+		}
+
+		return val;
+	}
+}
+
Index: ChangeLog
===================================================================
RCS file: /cvs/kaffe/kaffe/ChangeLog,v
retrieving revision 1.2476
diff -u -r1.2476 ChangeLog
--- ChangeLog	8 Jul 2004 10:41:39 -0000	1.2476
+++ ChangeLog	8 Jul 2004 12:31:20 -0000
@@ -1,3 +1,64 @@
+2004-07-08  Jim Huang  <jserv@kaffe.org>
+	* libraries/javalib/java/awt/AWTEvent.java:
+	* libraries/javalib/java/awt/ActionEvt.java:
+	* libraries/javalib/java/awt/AdjustmentEvt.java:
+	* libraries/javalib/java/awt/BarMenu.java:
+	* libraries/javalib/java/awt/Button.java:
+	* libraries/javalib/java/awt/Checkbox.java:
+	* libraries/javalib/java/awt/CheckboxMenuItem.java:
+	* libraries/javalib/java/awt/Choice.java:
+	* libraries/javalib/java/awt/Component.java:
+	* libraries/javalib/java/awt/ComponentEvt.java:
+	* libraries/javalib/java/awt/ContainerEvt.java:
+	* libraries/javalib/java/awt/Dialog.java:
+	* libraries/javalib/java/awt/EventQueue.java:
+	* libraries/javalib/java/awt/FileDialog.java:
+	* libraries/javalib/java/awt/FocusEvt.java:
+	* libraries/javalib/java/awt/Frame.java:
+	* libraries/javalib/java/awt/Image.java:
+	* libraries/javalib/java/awt/ImageNativeProducer.java:
+	* libraries/javalib/java/awt/ItemEvt.java:
+	* libraries/javalib/java/awt/KeyEvt.java:
+	* libraries/javalib/java/awt/Label.java:
+	* libraries/javalib/java/awt/List.java:
+	* libraries/javalib/java/awt/MenuComponent.java:
+	* libraries/javalib/java/awt/MenuItem.java:
+	* libraries/javalib/java/awt/MouseEvt.java:
+	* libraries/javalib/java/awt/PSGraphics.java:
+	* libraries/javalib/java/awt/RowCanvas.java:
+	* libraries/javalib/java/awt/ScrollPane.java:
+	* libraries/javalib/java/awt/Scrollbar.java:
+	* libraries/javalib/java/awt/TextArea.java:
+	* libraries/javalib/java/awt/TextComponent.java:
+	* libraries/javalib/java/awt/TextCursor.java:
+	* libraries/javalib/java/awt/TextEvt.java:
+	* libraries/javalib/java/awt/TextField.java:
+	* libraries/javalib/java/awt/Window.java:
+	* libraries/javalib/java/awt/WindowEvt.java:
+	Import kaffe.awt.Defaults.
+	
+	* libraries/javalib/profiles/allatonce/all.files:
+	* libraries/javalib/profiles/default/coreawt.files:
+	Change from java.awt.Defaults to kaffe.awt.Defaults.
+	
+	* libraries/javalib/java/awt/Font.java:
+	consult font.properties as default AWT font, make sure the font 
+	property description file locates in java.awt.
+	Import kaffe.awt.Defaults.
+	
+	* libraries/javalib/java/awt/FontMetrics.java
+	(getFontMetrics): better handling with caching font metrics list.
+	Import kaffe.awt.Defaults.
+
+	* libraries/javalib/java/awt/Toolkit.java
+	(run): wake up the Toolkit.clinit.
+	Import kaffe.awt.Defaults.
+	
+	* libraries/javalib/kaffe/awt/Defaults.java:
+	New file, move from java.awt.Defaults to kaffe.awt package.
+
+	* libraries/javalib/java/awt/Defaults.java: Removed.
+
 2004-07-08  Gwenole Beauchesne  <gbeauchesne@mandrakesoft.com>
 
 	* kaffe/kaffevm/systems/unix-jthreads/signal.c
